﻿#ifndef MYLIB_CK
#define MYLIB_CK

//    2009.01  Y.Okamoto

#include <iostream>
#include <fstream>
#include <sstream>

namespace myLib {

using namespace std;

//
//		x の平方を返す
//
double sqr( double x );


//
//  文字列sの表す整数値を返す
//
int strToInt( string s );


//
//   文字列sの表す実数値を返す
//
double strToDouble( string s );


bool check_c( char c );


 //
 //  空白で区切られた文字列からなるstring型sに
 //  含まれるipos番目の文字列を返す
 //
 string SeekStr( string s, int ipos );



 //
 //   テキストファイルから１行ごとに読み込むためのクラス型
 //
 class RdTxtLn {
 public:
   FILE * fin;
   int iCond;  //  0: OK,  1: End of File,  9: Open Error, -1: Not initialized
   string s;

   RdTxtLn(): iCond(-1) {}

   //
   //    nmに読み込み用テキストファイル名を設定
   //    オープンに成功すればiCondの値は0が設定される。
   //
   RdTxtLn( string nm ): iCond(0){
     fin = fopen( nm.c_str(), "r" );
     if (fin == NULL) {
       iCond = 9;
       return;
     } else {
       iCond = 0;
       return;
     }
     
   }

   virtual ~RdTxtLn(){
     if (iCond == 0) fclose(fin);
  }

   void open( string nm ){
     fin = fopen( nm.c_str(), "r" );
     if (fin == NULL) {
       iCond = 9;
       return;
     } else {
       iCond = 0;
       return;
     }
     
   }

   
   void close(){
     if (iCond == 0){
       fclose(fin);
       iCond = -1;
     }
   }

   //
   //   メソッドreadlineを１回呼び出すと
   //   ファイルから１行分がstrに読み込まれる
   //
   int readline( string & str ){
     int v = 0;
     if (iCond != 0){
       v = 1;
       return v;
     }
     const int maxN = 1000;
     char c[maxN];
     int ipos = 0;
     int cv;
     while (true){
       cv = fgetc(fin);
       if (cv == EOF){
	 c[ipos] = 0;
	 str = "";
	 if (ipos > 0)
	   for (int i = 0; i < ipos; i++)
	     str += c[i];
	 iCond = 1;
	 return v;
       }
       switch (char(cv)){
       case '\r': break; 
       case '\n': c[ipos] = 0; ipos *= -1; break;
       default  : c[ipos] = char(cv);
		  ipos++;
		  if (ipos > (maxN-2)){
		    c[maxN-1] = 0;
		    v = 9;
		    return v;
		  }		  
		  break;
       }
       if (ipos <= 0) {
	 ipos *= -1;
	 str = "";
	 if (ipos > 0)
	   for (int i = 0; i < ipos; i++)
	     str += c[i];
	 v = 0;
	 return 0;
       }
     }
   }

 };

}  //  myLib

#endif

